#include "computer.h"
#include <QDesktopServices>
#include <QUrl>

Computer::Computer() : hostname(), port(2000), name()
{
}

Computer::Computer(const Computer &c) : QObject(), hostname(c.hostname), port(c.port), name(c.name)
{
}

Computer &Computer::operator=(const Computer &c)
{
	hostname = c.hostname;
	name = c.name;
	port = c.port;
	return *this;
}

bool Computer::operator!=(const Computer &c)
{
	return c.port != port || c.name != name || c.hostname != hostname;
}

void Computer::open(const QString &path) const
{
	QDesktopServices::openUrl(QUrl("ftp://" + hostname + ":" + QString::number(port) + path));
}

QString Computer::getHostname() const
{
	return hostname;
}

QString Computer::getName() const
{
	return name;
}

int Computer::getPort() const
{
	return port;
}

void Computer::setPort(const int port)
{
	this->port = port;
}

void Computer::setHostname(const QString &hostname)
{
	this->hostname = hostname;
}

void Computer::setName(const QString &name)
{
	this->name = name;
}

bool operator!=(const Computer &a, const Computer &b)
{
	return a.getHostname() != b.getHostname() || a.getName() != b.getName() || a.getPort() != b.getPort();
}
