#ifndef COMPUTER_H
#define COMPUTER_H

#include <QObject>

class Computer : public QObject
{
	Q_OBJECT
public:
    Computer();
	Computer(const Computer &c);
	Computer &operator=(const Computer &c);
	bool operator!=(const Computer &c);

	QString getHostname() const;
	QString getName() const;
	int getPort() const;

public slots:
	void open(const QString &path = QString()) const;
	void setHostname(const QString &hostname);
	void setName(const QString &name);
	void setPort(const int port);

private:
	QString hostname;
	int port;
	QString name;
};

bool operator!=(const Computer &a, const Computer &b);

#endif // COMPUTER_H
