#ifndef CONFIG_H
#define CONFIG_H

#include <QtGui/QDialog>
#include <QMutex>
#include <QTableWidgetItem>

namespace Ui {
    class Config;
}

class Config : public QDialog, public QMutex {
    Q_OBJECT
public:
    Config(QWidget *parent = 0);
    ~Config();

	bool isAnonymous();
	QString getPassword();
	QString getLogin();
	QString getHostname();
	int getServerPort();

public slots:
	void updateServerStatus();
	void saveSettings();
	void addFolder();
	void removeFolder();
	void editFolder(QTableWidgetItem *item);
	void editPath(QTableWidgetItem *item);
	void loadFolders();
	void changeLanguage();
	void loadLanguages();
protected:
    void changeEvent(QEvent *e);
	void loadSettings();
private:
    Ui::Config *m_ui;
	QList<QString> folderNames;

private:
	static Config *pInstance;
public:
	static Config *instance();
	static void deleteInstance();
};

#endif // CONFIG_H
