#ifndef FTPSERVER_H
#define FTPSERVER_H

#include <QTcpServer>
#include <QList>

class FtpServer : public QObject
{
	Q_OBJECT

	friend class RETRcmd;
	friend class FINDcmd;
	friend class STORcmd;
	friend class LISTcmd;
public:
	struct ConnectionInfo
	{
		QString user;
		QString address;
		QString activity;
	};
public:
	FtpServer(int port);
	~FtpServer();
	QList<ConnectionInfo> getInfo();
	int nbConnections();

public slots:
	void addConnection();
	void statsSend(int);
	void statsRecv(int);
	void killThread();

signals:
	void newThread();
	void removeThread();
	void closing();

private:
	QTcpServer *sock;
	// For statistics
	quint64 totalSent;
	quint64 totalReceived;
	int maxConnections;
	int totalConnections;

private:
	static FtpServer *pInstance;
public:
	static void startServer();
	static void stopServer();
	static void restartServer();
	static bool serverRunning();
	static QList<ConnectionInfo> getClientsInfo();
	static QStringList getServerInfo();
};

#endif // FTPSERVER_H
