#include <QtGui/QApplication>
#include <QTranslator>
#include <QLocale>
#include <QSettings>
#include <QSplashScreen>
#include <QTimer>
#include "mainwindow.h"

QTranslator *qShareTranslator = NULL;
QTranslator *qQtTranslator = NULL;

int main(int argc, char *argv[])
{
	QApplication a(argc, argv);
	QApplication::setApplicationName("qshare");
	QApplication::setOrganizationName("zuzuf");
	QApplication::setApplicationVersion("v 1.3");

	QSplashScreen *splash = new QSplashScreen(QPixmap(":/images/splash.jpg"), Qt::WindowStaysOnTopHint);
	QTimer *timer = new QTimer;
	timer->setSingleShot(true);
	timer->setInterval(1000);
	QTimer::connect(timer, SIGNAL(timeout()), splash, SLOT(deleteLater()));
	QTimer::connect(timer, SIGNAL(timeout()), timer, SLOT(deleteLater()));
	if (argc == 1)
		splash->show();

	qShareTranslator = new QTranslator;
	qQtTranslator = new QTranslator;
	bool showMainWindow = false;
	{
		QSettings settings;
		QString localeSuffix = settings.value("locale", QLocale::system().name().left(2)).toString() + ".qm";
		qShareTranslator->load(":/i18n/qshare_" + localeSuffix);
		qQtTranslator->load(":/i18n/qt_" + localeSuffix);
		showMainWindow = settings.value("firstStart", true).toBool();
		settings.setValue("firstStart", false);
	}
	a.installTranslator(qShareTranslator);
	a.installTranslator(qQtTranslator);

	a.setQuitOnLastWindowClosed(false);
    MainWindow w;
	if (showMainWindow)
		w.show();

	timer->start();

	return a.exec();
}
