#ifndef NETDISCOVERY_H
#define NETDISCOVERY_H

#include <QThread>
#include <QStringList>
#include <QMap>
#include <QHostAddress>
#include <QMutex>
#include "computer.h"

class NetDiscovery : public QThread
{
	Q_OBJECT
public:
    NetDiscovery();

	void run();

	QList<Computer> getServerList();
	Computer getComputer(const QString &name);

public slots:
	void setOrUpdate(const QString &data, const QHostAddress &host);
	void terminate();
	void setNotifyRate(int rate);
	void forceRefresh();
	void remove(const QHostAddress &host);

signals:
	void serverListChanged();

private:
	int notifyRate;
	bool refreshForced;
	QMutex mutex;
	bool stop;
	QMap<QString, Computer>	mServer;

public:
	static NetDiscovery *pInstance;
};

#endif // NETDISCOVERY_H
